// Inmatning.java

// INMATNING: 

// Matar in med riktiga ,,.
// Ledtexter och inmatningskontroll.

// Version: 0.97

//      Copyright (c) 2012 Per Tunedal, Stockholm, Sweden
//       Author: Per Tunedal <info@tunedal.nu>

//       This program is free software: you can redistribute it and/or modify
//       it under the terms of the GNU General Public License as published by
//       the Free Software Foundation, either version 3 of the License, or
//       (at your option) any later version.

//       This program is distributed in the hope that it will be useful,
//       but WITHOUT ANY WARRANTY; without even the implied warranty of
//       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//       GNU General Public License for more details.

//       You should have received a copy of the GNU General Public License
//       along with this program.  If not, see <http://www.gnu.org/licenses/>.


// Notes
// =====

// v. 0.1 Comments etc mainly in Swedish.
// v. 0.2 Minor improvements
// v. 0.97
// --------------------------------------

// Demonstrerar:
// Klass med flera metoder med samma namn
// som skiljer sig t genom olika antal parametrar

package per.edu;

import java.io.*;
import java.util.*;
import java.awt.*; // Beep

public class Inmatning

{

	// Inmatning av en rad (strng)
	
	public static String rad () throws Exception
	// lgg till hantering av undantagen:
	// kasta med egna felmeddelanden!
	
	{

		// Frbereder inmatning med rtt tecken.
		// =====================================
		// Klassen InputStreamReader frn paketet java.util
		// ------------------------------------------------
		//Frutstter: import java.util.*;
		
		InputStreamReader isr = new InputStreamReader (System.in, "Cp850");
		Scanner sin = new Scanner (isr);
		
		// Matar in en strng
		// ==================

		// Inmatningen ger korrekta ,,:
		String text = sin.nextLine ();
		return text;
	}
	
	// Inmatning av en rad (strng) med frga
	
		public static String rad (String ask) throws Exception
	// lgg till hantering av undantagen:
	// kasta med egna felmeddelanden!
	
	{

		// Frbereder inmatning med rtt tecken.
		// =====================================
		// Klassen InputStreamReader frn paketet java.util
		// ------------------------------------------------
		//Frutstter: import java.util.*;
		
		InputStreamReader isr = new InputStreamReader (System.in, "Cp850");
		Scanner sin = new Scanner (isr);
		
		// Skriver ut en frga
		// ===================

		//Utskrift.skrivText (ask); // Hittar inte klassen! Trots samma katalog.
		// Hur gr man?? Borde kunna anvnda metoder frn egna klasser
		// frn andra egna klasser i samma egna paket!
		
		OutputStreamWriter  osw = new OutputStreamWriter (System.out, "Cp850");
		PrintWriter out = new PrintWriter (osw, true);
		
		out.println (ask);
		
		// Matar in en strng
		// ==================
	
		// Inmatningen ger korrekta ,,:
		String text = sin.nextLine ();
		return text;
	}
	
		// Inmatning av en rad (strng) med frga
		// samt inmatningskontroll
	
		public static String rad (String ask, String allowed) throws Exception
		// Obs! allowed = regex!
		
		// lgg till hantering av undantagen:
		// kasta med egna felmeddelanden!
	
	{

		// Frbereder inmatning med rtt tecken.
		// =====================================
		// Klassen InputStreamReader frn paketet java.util
		// ------------------------------------------------
		//Frutstter: import java.util.*;
		
		InputStreamReader isr = new InputStreamReader (System.in, "Cp850");
		Scanner sin = new Scanner (isr);
		
		// Skriver ut en frga
		// ===================

		//Utskrift.skrivText (ask); // Hittar inte klassen! Trots samma katalog.
		// Hur gr man?? Borde kunna anvnda metoder frn egna klasser
		// frn andra egna klasser i samma egna paket!
		
		OutputStreamWriter  osw = new OutputStreamWriter (System.out, "Cp850");
		PrintWriter out = new PrintWriter (osw, true);
		
		out.println (ask); // Skriver ut frgan
		
		// Matar in en strng
		// ==================
		// Inmatningen ger korrekta ,,:
		
		// Kontrollera att inmatningen r tillten
		String text = "";
		while (true)
			{
				text = sin.nextLine ();

				if (text.matches(allowed)) break;
				Toolkit.getDefaultToolkit().beep(); // Krver import java.awt.*;				
				out.println ("*** FEL ***");
				out.println ("tilltet: " + allowed  + "\n" + ask);

			}
		
		return text;
	}
	
		// Inmatning av en rad (strng) med frga
		// samt inmatningskontroll: stopp-ord
		// och felmeddelande
	
		public static String rad (String ask, String[] stop, String meddelande) throws Exception
		
		// lgg till hantering av undantagen:
		// kasta med egna felmeddelanden!
	
	{

		// Frbereder inmatning med rtt tecken.
		// =====================================
		// Klassen InputStreamReader frn paketet java.util
		// ------------------------------------------------
		//Frutstter: import java.util.*;
		
		InputStreamReader isr = new InputStreamReader (System.in, "Cp850");
		Scanner sin = new Scanner (isr);
		
		// Skriver ut en frga
		// ===================

		//Utskrift.skrivText (ask); // Hittar inte klassen! Trots samma katalog.
		// Hur gr man?? Borde kunna anvnda metoder frn egna klasser
		// frn andra egna klasser i samma egna paket!
		
		OutputStreamWriter  osw = new OutputStreamWriter (System.out, "Cp850");
		PrintWriter out = new PrintWriter (osw, true);
		
		out.println (ask); // Skriver ut frgan
		
		// Matar in en strng
		// ==================
		// Inmatningen ger korrekta ,,:
		
		// Kontrollera att inmatningen r tillten
		String text = "";
		while (true)
			{
				text = sin.nextLine ();

				// Jmfr med uteslutningsordlista
				// bryter vid <0 dvs. ingen trff
				if (Arrays.binarySearch (stop, text) < 0) break;	
				//if (text.matches(allowed)) break;
				Toolkit.getDefaultToolkit().beep(); // Krver import java.awt.*;				
				out.println ("***" + meddelande + "***" + "\n" + ask);
			}
		
		return text;
	}
	
	// Inmatning av ett decimaltal(double)
	
	public static double decimaltal () throws Exception
	// lgg till hantering av undantagen:
	// kasta med egna felmeddelanden!
	
	{
		// Frbereder inmatning
		// ====================
		
		//Frutstter: import java.util.*;

		Scanner  in = new Scanner (System.in);
		
		// Frbereder utmatning
		// ====================
		
		OutputStreamWriter  osw = new OutputStreamWriter (System.out, "Cp850");
		PrintWriter out = new PrintWriter (osw, true);

		// Inmatning
		// =========

		// Heltalsinmatining med metoden nextDouble
		
				while (!in.hasNextDouble())
		{
			out.println ("Detta r inte ett decimaltal!");
			in.nextLine (); // rensar bufferten
		}

		double n = (double) in.nextDouble ();

		// rensning av bufferten
		in.nextLine ();
		return n;
	}
	
	// Inmatning av ett heltal(int)
	
	public static int heltal () throws Exception
	// lgg till hantering av undantagen:
	// kasta med egna felmeddelanden!
	
	{
		// Frbereder inmatning
		// ====================
		
		//Frutstter: import java.util.*;

		Scanner  in = new Scanner (System.in);
		
		// Frbereder utskrift
		// ===================
		
		OutputStreamWriter  osw = new OutputStreamWriter (System.out, "Cp850");
		PrintWriter out = new PrintWriter (osw, true);

		// Inmatning
		// =========

		// Heltalsinmatining med metoden nextInt
		
		while (!in.hasNextInt())
		{
			out.println ("Detta r inte ett heltal!");
			in.nextLine (); // rensar bufferten
		}

		int n = (int) in.nextInt ();

		// rensning av bufferten
		in.nextLine ();
		return n;
	}

	// Inmatning av ett decimaltal(double) med frga
	
	public static double decimaltal (String ask) throws Exception
	// lgg till hantering av undantagen:
	// kasta med egna felmeddelanden!
	
	{
		// Frbereder inmatning
		// ====================
		
		//Frutstter: import java.util.*;

		Scanner  in = new Scanner (System.in);
		
		// Skriver ut en frga
		// ===================
		
		OutputStreamWriter  osw = new OutputStreamWriter (System.out, "Cp850");
		PrintWriter out = new PrintWriter (osw, true);
		
		out.println (ask); // Skriver ut frgan		

		// Inmatning
		// =========

		// Decimaltalsinmatning med metoden nextDouble
		
				while (!in.hasNextDouble())
		{
			out.println ("Detta r inte ett decimaltal!");
			in.nextLine (); // rensar bufferten
		}

		double n = (double) in.nextDouble ();

		// rensning av bufferten
		in.nextLine ();
		return n;
	}
	

	// Inmatning av ett heltal(int) med frga
	
	public static int heltal (String ask) throws Exception
	// lgg till hantering av undantagen:
	// kasta med egna felmeddelanden!
	
	{
		// Frbereder inmatning
		// ====================
		
		//Frutstter: import java.util.*;

		Scanner  in = new Scanner (System.in);
		
		// Skriver ut en frga
		// ===================
		
		OutputStreamWriter  osw = new OutputStreamWriter (System.out, "Cp850");
		PrintWriter out = new PrintWriter (osw, true);

		out.println (ask); // Skriver ut frgan			

		// Inmatning
		// =========

		// Heltalsinmatining med metoden nextInt
		
		
		while (!in.hasNextInt())
		{
			out.println ("Detta r inte ett heltal!");
			in.nextLine (); // rensar bufferten
		}

		int n = (int) in.nextInt ();

		// rensning av bufferten
		in.nextLine ();
		return n;
	}
	
	// Inmatning av ett heltal(int) med frga och kontroll
	
	public static int heltal (String ask, int max) throws Exception
	// lgg till hantering av undantagen:
	// kasta med egna felmeddelanden!
	
	{
		// Frbereder inmatning
		// ====================
		
		//Frutstter: import java.util.*;

		Scanner  in = new Scanner (System.in);
		
		// Skriver ut en frga
		// ===================
		
		OutputStreamWriter  osw = new OutputStreamWriter (System.out, "Cp850");
		PrintWriter out = new PrintWriter (osw, true);

		out.println (ask); // Skriver ut frgan			

		// Inmatning
		// =========

		// Heltalsinmatining med metoden nextInt
		
		// 			if (text.matches(allowed)) break;
		int n = 0;
		while (!in.hasNextInt() || max < (n = (int) in.nextInt ()))
		{
			out.println ("Fel. Frsk igen!");
			in.nextLine (); // rensar bufferten
		}

		//int n = (int) in.nextInt ();

		// rensning av bufferten
		in.nextLine ();
		return n;
	}
}